<?php
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: poweroptions.php,v 1.7 2001/10/20 00:14:50 jcheng Exp $

include("ServerScriptHelper.php");
include("uifc/Label.php");
include("uifc/Option.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

if (!$action) {
  $action = "display";
}

// if $useExistingData is true, the page will display the data
// that exists in global variables, rather than looking up the data
// in CCE. That enables us to return errors without blowing away
// all user data.
$useExistingData = ($action == "commit") ? true : false;


// HANDLE PAGE
if ($action == "commit") {
  $errors = handlePage($powermode, $wakemode);

  genPage($useExistingData, $errors);

} else if ($action == "display") {

// DISPLAY PAGE
  genPage($useExistingData);
}

$serverScriptHelper->destructor();
exit;



function genPage($useExistingData, $errors = array()) {
  global $cceClient;
  global $serverScriptHelper;
  global $powermode;

  $factory = $serverScriptHelper->getHtmlComponentFactory("base-power", "/base/power/poweroptions.php?action=commit");
  $i18n = $factory->getI18n();

  if (!$useExistingData) {
    list($sysoid) = $cceClient->find("System");
    $ccePowerOpts = $cceClient->get($sysoid, "Power");
    $powermode = $ccePowerOpts["powermode"];
    $wakemode = $ccePowerOpts["wakemode"];
  }

  $page = $factory->getPage();
  
  $block = $factory->getPagedBlock("powerOptions_block");
  
  //using a multichoice dropdown
  
  $powerModeField = $factory->getMultiChoice("powermode");
  $powerModeField->setFullSize(true);

  $sameOption = $factory->getOption("same", $powermode == "same");
  $powerModeField->addOption($sameOption);
  
  $offOption = $factory->getOption("off", $powermode == "off");
  $powerModeField->addOption($offOption);
  
  $onOption = $factory->getOption("on", $powermode == "on");
  $powerModeField->addOption($onOption);
  
  $block->addFormField($powerModeField, $factory->getLabel("powermode"));
  
  $block->addButton($factory->getSaveButton($page->getSubmitAction()));

  //using a multichoice dropdown
   
  $wakeModeField = $factory->getMultiChoice("wakemode");
  $wakeModeField->setFullSize(true);
  
  $noneOption = $factory->getOption("none", $wakemode == "none");
  $wakeModeField->addOption($noneOption);
  
  $magicOption = $factory->getOption("magic", $wakemode == "magic");
  $wakeModeField->addOption($magicOption);

  $block->addFormField($wakeModeField, $factory->getLabel("wakemode"));
  
  //Add error handling to page
  $block->process_errors($errors, array("wakemode" => "wakemode", "powermode" => "powermode"));

  //Reboot and Shutdown buttons
  //create the button
  $rebootbutton = $factory->getButton("javascript: confirmReboot()", "reboot");
  
  //confirmation string
  $confirm =  $i18n->get("askRebootConfirmation");
  
  //create the script
  $rebootScript =
"    <SCRIPT LANGUAGE=\"javascript\">
    function confirmReboot()
  {
    if (confirm(\"$confirm\"))
      {
	location = \"/base/power/rebootHandler.php\"
	  }
  }
  </SCRIPT>";

  //Shutdown button
  $shutdownbutton = $factory->getButton("/base/power/shutdown.php", "shutdown_menu");
  
  $buttons = $factory->getCompositeFormField(array($rebootbutton, $shutdownbutton), '&nbsp;&nbsp;&nbsp;&nbsp;');

  print($page->toHeaderHtml());
  print($buttons->toHtml());
  print($rebootScript);
  print("<BR>\n");
  print($block->toHtml()); 
  print($page->toFooterHtml()); 
}


function handlePage($powermode, $wakemode) {
  global $cceClient;

  $cceClient->setObject("System", array("powermode" => $powermode, "wakemode" => $wakemode), "Power");

  return $cceClient->errors();
}
?>
