<?php
// Author: Phil Ploquin
// Copyright 2000, 2001 Sun Microsystems, Inc.  All rights reserved.

include("ServerScriptHelper.php");
include_once('Error.php');

$serverScriptHelper = new ServerScriptHelper($sessionId);
$i18n = $serverScriptHelper->getI18n("base-power");
$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-power",
                                         "/base/power/rebootHandler.php");

if ($cceClient->suspended() !== false)
{
	$msg = $cceClient->suspended() ? $cceClient->suspended() : '[[base-cce.suspended]]';
	print $serverScriptHelper->toHandlerHtml(
		"/base/power/poweroptions.php", array(new Error($msg)), false);
	exit;
}

$page = $factory->getPage();

print($page->toHeaderHtml());
print $i18n->get("rebooting") . '<br>';
print($page->toFooterHtml());

$sysoid = $cceClient->find("System");
$cceClient->set($sysoid, "Power", array("reboot" => time()));

$serverScriptHelper->destructor();
?>
