<?php
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: wakenow.php,v 1.4 2001/05/23 23:35:03 jcheng Exp $

include("ServerScriptHelper.php");
include("uifc/Label.php");
include("uifc/TextList.php");
include("uifc/Button.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

if (!$action) {
  $action = "display";
}

// if $useExistingData is true, the page will display the data
// that exists in global variables, rather than looking up the data
// in CCE. That enables us to return errors without blowing away
// all user data.
$useExistingData = ($action == "commit") ? true : false;

//HANDLE PAGE
if ($action == "commit") {
  $errors = handlePage($mac_addresses);

  genPage($useExistingData, $errors);

} else if ($action == "display") {

//DISPLAY PAGE
  genPage($useExistingData);
}

$serverScriptHelper->destructor();
  
exit;




function genPage($useExistingData, $errors = array()) {
  global $cceClient;
  global $serverScriptHelper;
  global $mac_addresses;

  $factory = $serverScriptHelper->getHtmlComponentFactory("base-power", "/base/power/wakenow.php?action=commit");
  
  if (!$useExistingData) {
    list($sysoid) = $cceClient->find("System");
    $cceWakeOpts = $cceClient->get($sysoid, "Power");
    $mac_addresses = $cceWakeOpts["wake_macaddresses"];
  }
  
  $page = $factory->getPage();
  
  $wakeNowBlock = $factory->getPagedBlock("wakeNow_block");

  //using a multichoice dropdown
  
  $macList = $factory->getTextList("mac_addresses", $mac_addresses, "rw");
  $wakeNowBlock->addFormField($macList, $factory->getLabel("mac_addresses"));
  $wakeNowBlock->addButton($factory->getButton($page->getSubmitAction(), "wakenow_button"));
  
  //Add error handling to page
  $wakeNowBlock->process_errors($errors, array("wake_macaddresses" => "mac_addresses"));

  print($page->toHeaderHtml());
  print($wakeNowBlock->toHtml());
  print($page->toFooterHtml()); 
}



function handlePage($mac_addresses) {
  global $cceClient;

  $cceClient->setObject("System", array("wake_macaddresses" => $mac_addresses, "wake_now" => time()), "Power");
  return $cceClient->errors();
}

?>

