<?php
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: wakeoptions.php,v 1.5 2001/09/28 00:42:31 thockin Exp $

include("ServerScriptHelper.php");
include("uifc/Label.php");
include("uifc/Option.php");
include("uifc/TextList.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

if (!$action) {
  $action = "display";
}

// if $useExistingData is true, the page will display the data
// that exists in global variables, rather than looking up the data
// in CCE. That enables us to return errors without blowing away
// all user data.
$useExistingData = ($action == "commit") ? true : false;

// HANDLE PAGE
if ($action == "commit") {
  $errors = handlePage($wakemode);

  genPage($useExistingData, $errors);

} else if ($action == "display") {

// DISPLAY PAGE
  genPage($useExistingData);
}

$serverScriptHelper->destructor();
exit;


function genPage($useExistingData, $errors = array()) {
  global $cceClient;
  global $serverScriptHelper;
  global $wakemode;

  $factory = $serverScriptHelper->getHtmlComponentFactory("base-power", "/base/power/wakeoptions.php?action=commit");

  if (!$useExistingData) {
    list($sysoid) = $cceClient->find("System");
    $cceWakeOpts = $cceClient->get($sysoid, "Power");
    $wakemode = $cceWakeOpts["wakemode"];
  }

  $page = $factory->getPage();
  
  $modeBlock = $factory->getPagedBlock("wakeMode_block");
  
  //using a multichoice dropdown
   
  $wakeModeField = $factory->getMultiChoice("wakemode");
  
  $noneOption = $factory->getOption("none", $wakemode == "none");
  $wakeModeField->addOption($noneOption);
  
  $magicOption = $factory->getOption("magic", $wakemode == "magic");
  $wakeModeField->addOption($magicOption);
  
  $modeBlock->addFormField($wakeModeField, $factory->getLabel("wakemode"));
  
  $modeBlock->addButton($factory->getSaveButton($page->getSubmitAction()));
  
  //Add error handling to page
  $modeBlock->process_errors($errors, array("wakemode" => "wakemode"));

  print($page->toHeaderHtml());
  print($modeBlock->toHtml()); 
  print($page->toFooterHtml()); 
}


function handlePage($wakemode) {
  global $cceClient;

  $cceClient->setObject("System", array("wakemode" => $wakemode), "Power");
  
  return $cceClient->errors();
}


?>
